%global major 1
%global minor 0
%global patch 0

Name:           rpi-userland
Version:        %{major}.%{minor}.%{patch}.git.886.5b6440d3
Release:        6%{?dist}
Summary:        Userland tools and libs for the Raspberry Pi

License:        BSD-3
URL:            https://github.com/raspberrypi/userland
VCS:            git+https://github.com/Leuca/rpi-userland#5b6440d39a0bfc2b8ed8214933789e0b263b5dc3:

ExclusiveArch:  aarch64

BuildRequires:  git
BuildRequires:  gcc
BuildRequires:  gcc-c++
BuildRequires:  cmake
BuildRequires:  make
BuildRequires:  glibc-devel
BuildRequires:  libfdt-devel

Provides:       vcgencmd

Source:         rpi-userland-5b6440d3.tar.gz

Patch0:         rpi-userland-add-soversion.patch
Patch1:         rpi-userland-libfdt-fix.patch

%description
Raspberry Pi ARM side libraries and utilities.
ARM side code to interface to: mmal, vcos, vchiq_arm, bcm_host.

%package    examples
Requires:       %{name}
Summary:        Userland hello-pi source code

%description    examples
Provides the 'hello-pi' source code from rpi-userland Raspberry Pi ARM side libraries and utilities.

%package    devel
Requires:   %{name}%{?_isa} = %{version}-%{release}
Summary:    Development package for %{name}

%description    devel
Files needed to develop with %{name}


%prep
%setup -T -b 0 -q -n rpi-userland
%autopatch -p1

%build
%cmake \
        -DARM64:BOOL=ON \
        -DCMAKE_BUILD_TYPE=Release \
        -DBUILD_SHARED_LIBS:BOOL=ON \
        -DBUILD_STATIC_LIBS:BOOL=OFF \
        -DVMCS_INSTALL_PREFIX=%{_prefix} \

%cmake_build

%install
%cmake_install
%ifarch aarch64
mv %{buildroot}%{_prefix}/lib %{buildroot}%{_libdir}
%endif
mkdir -p %{buildroot}%{_datadir}
mv %{buildroot}%{_prefix}/man %{buildroot}%{_datadir}

%files
%license LICENCE
%{_bindir}/*
%{_libdir}/*.so.*
%{_mandir}/*

%files examples
%{_usrsrc}/*

%files devel
%{_includedir}/IL/*
%{_includedir}/VG/*
%{_includedir}/WF/*
%{_includedir}/bcm_host.h
%{_includedir}/interface/*
%{_includedir}/vcinclude/*
%{_libdir}/pkgconfig/bcm_host.pc
%{_libdir}/pkgconfig/brcmvg.pc
%{_libdir}/pkgconfig/mmal.pc
%{_libdir}/pkgconfig/vcsm.pc
%{_libdir}/*.so
%ghost %{_includedir}/EGL/*
%ghost %{_includedir}/GLES/*
%ghost %{_includedir}/GLES2/*
%ghost %{_includedir}/KHR/*
%ghost %{_libdir}/pkgconfig/brcmegl.pc
%ghost %{_libdir}/pkgconfig/brcmglesv2.pc


%changelog
* Mon Oct 31 2022 Luca Magrone <luca@magrone.cc> 0.0.0-5
- Do not explicitly provide libfdt anymore
- Remove unused dependency
- spec: add patch to add soversion
- Add soversion to shared objects
- Add new shared objects

* Sat Jun 25 2022 Luca Magrone <luca.magrone@me.com> 0.5-4
- remove reference to inexistent files

* Fri Jun 24 2022 Luca Magrone <luca.magrone@me.com> 0.4-4
- spec: add missing plugins directory
- do not build client,openmax when 64 bit
- enable sm libs in 64 bits build
- mmal: enable 64 bits build, pull: use rebase
- Merge pull request #4 from raspberrypi/master
- hello_pi: Fix some build issues
- specfile: provide libfdt.so
- specfile: remove empty lines

* Sat Jun 04 2022 Luca Magrone <luca.magrone@me.com> 0.3-4
- specfile: add -DBUILD_STATIC_LIBS:BOOL=OFF to cmake cmd

* Sat Jun 04 2022 Luca Magrone <luca.magrone@me.com> 0.2-4
- specfile: separate headers that are messing with other libraries

* Fri Jun 03 2022 Luca Magrone <luca.magrone@me.com> 0.1-3
- specfile: better compliance with fedora guidelines
- Update rpi-userland.template.spec
- Create rpi-userland.template.spec
- Create pull.yml
- Fix raspicommonsettings_parse_cmdline
- mmal: Add mapping for IL OMX_IndexParamBrcmEnableIJGTableScaling param
- dtoverlay: Don't mix non-fatal errors and offsets
- dtoverlay: Rebase aliases in overlays like labels
- userland: dtoverlay: Handle parameters in overlay_map
- vcos: Add vcos_safe_strncpy and VCOS_SAFE_STRNCPY
- mmal: Hack to make mmal core register VideoCore components
- raspicam: Check system is running legacy camera stack
- hello_fft: Remove unused function declaration
- hello_fft: Update outdated link to V3D spec
- interface/vcos: Get rid of LLTHREAD cast warning
- userland: Reduce debug_sym error messages
- video_decode: Option to stop decode on aspect ratio & colourspace changes
- isp: Add SW colour denoise configuration
- vcgencmd: Fix documentation URL
- tvservice: Add check to warn when running with kms
- dtoverlay: Break on an error when parsing fragment overrides
- bcm_host: Recognise all Pi 4 variants, add BCM2711
- vcsm: properly handle too many CMA allocation attempts
- Add man-pages for most commands
- Update board revision codes
- video_decode: Add parameter to disable timestamp validation
- MMAL/IL: Add support for the 16bpp Bayer/Grey raw 10/12/14 formats
- RaspiCam: Correct rotation param docs to be 0/90/180/270
- Remove vcfiled and vcfilesys
- vec: Support PAL-N.
- vc_image_helper: Avoid misaligned exception due to uninitialised pointer
- vc_service: Fix enum types to string lookup
- host_applications: Install debug_sym.h
- MMAL/IL/ISP component: Add support for mono MIPI formats, and Bayer raw 14
- RaspiStillYUV: Add the equivalent "all manual" patch for faster captures.
- interface/mmal: Reduce the header bytes alloc in the MMAL examples
- Remove vcfiled and vcfilesys.
- Fix cast warning on vcos_llthread_current
- Revert "Add MMAL and MMAL_APPS to 64bit builds"
- Fix compiler warning
- raspicam: Fix up whitespace
- WF: Fix copyright headers
- raspicam: Allow tainted check to be skipped
- Link raspicam applications with -lm
- vc_sm_cma_ioctl.h: Correct licence
- arm_loader: Add SET_LAUNCH_VPU1 mailbox message
- video_encode: Add option to include header bytes with frame
- mmal/vc: Add mapping for OMX_IndexConfigBufferStall /
MMAL_PARAMETER_VIDEO_STALL_THRESHOLD
- isp: allow more formats of lens shading tables, including corner-sampled and
16-bit
- isp: add application control of the gamma block
- isp: add application control of (automatic) Defective Pixel Correction (DPC)
block
- isp: add application control of sharpen block
- isp: add application control of Green Equalisation (GEQ) parameters
- isp: add application control of spatial denoise parameters
- isp: Allow setting Black Level for all 3 channels (whilst still preserving the
old single channel method).
- isp: Add stats port to enable userspace 3A algorithms
- Revert "mmal: Support 64 bit clients"
- vc_image: Add vpitch parameter to VC_IMAGE_T for Bayer images
- Revert "tvservice: Fix freeze on old firmware. (#617)"
- Fix up demo apps to abort when used on Pi4
- hello_pi: Add top level makefile and enable parallel build
- raspistill: Add option to start in burst mode if AE settings are manual
- MMAL / video_render: Allow column stride to be set on column formats
- raspicam: Adjust framerate limits on long exposures for stills port.
- raspistill: Adjust framerate limits on long exposures. (#622)
- raspicam: Add option to draw a focus window with FoM value. (#621)
- Fix header enum typo
- tvservice: Fix freeze on old firmware. (#617)
- Remove libc++ dependency
- dtoverlay: Add overlay_map functionality
- dtoverlay: Fix whitespace problems
- debug_sym: Fixup whitespace issues from previous patch.
- vcdbg/debugsym: Add option to specify the file size.
- vc_image/video_decode: Move +16 lines for di_adv from vc_image to decoder
- dtoverlay: Support intra-overlay fragments
- libdtovl: Add support for intra-overlay fragments
- dtoverlay: A dry run needs no config directory
- dtoverlay: Preserve exported labels
- libdtovl: Rewrite and merge exported labels
- libdtovl: Allow labels to be exported
- CMakeLists: Remove unwanted quoting See:
https://github.com/raspberrypi/userland/issues/603
- dtoverlay: remove $EUID != 0 case
- dtoverlay: only run lxpanelctl hooks when lxpanel is running
- vc_image: Default YUVUV to non-tall mode, with flag if required.
- dtoverlay: Trim trailing whitespace from a symbol name
- dtoverlay: Extend DT parameter syntax
- dtoverlay: Add functions to walk pinctrl node
- dtoverlay: Plug small memory leak
- Update libfdt to v1.5.1+
- vmcs_host/vcilcs: build only on 32 bit
- Add MMAL and MMAL_APPS to 64bit builds
- MMAL and vcsm fixups for 64bit builds
- raspicam: Fix up so that it doesn't include brclegl libraries on 64 bit
- mmal: Support 64 bit clients
- Fix confusing typo swapping _MAP and _ALLOC
- uservcsm: Fix incorrect struct type
- Update the GPS version to 23
- Replace 'arch' with uname
- Remove legacy pkgconfig to avoid Mesa conflicts
- Fixed hello_fft test cases with larger batch size (#581)
- Raspicam: Add 3D controls to RaspistillYUV and RaspiVidYUV
- vcsm: If /dev/vcsm fails, then try /dev/vcsm-cma not already tried.
- bcm_host: Add support for querying processor type and fkms status
- vcsm: Add vcsm_clean_invalid2 to vcsm_cma
- vcsm: Add support for vcsm_vc_addr_from_hdl to vcsm-cma path
- raspicam: Add -dn option to set the DispmanX display number
- Update issue templates
- bcm_host: Adjust for 64-bit physical addresses
- fixup! Add full support for Argon10 as a new image format
- dtoverlay: Update to stop lxpanel alsa correctly
- vcsm: Fixup vcsm_clean_invalid2
- user-vcsm: Remove an erroneous debug line from vcsm_free.
- user-vcsm: Add option to pass in an external fd to vcsm
- uservcsm: Error if export requested and existing connection doesn't use it.
- user-vcsm: Add a local copy of the kernel dma-buf.h uapi header
- user-vcsm: Reinstate vcsm_init as a funtion (not an inline)
- user_vcsm: Use const char* for names of objects
- vc-sm-cma support
- Fix up demo apps to abort when used on Pi4
- EDID: Add HDMI_I2C driver for 2711
- mmal_vc_shm: Expand error message
- mmal_vc_shm: Refcount init/exit, and call on component create/destroy
- Fix tvservice -d option
- Change to tvservice commands
- tvservice backwards compatibility
- vcimage: Add basic support for VC_IMAGE_RGBA1010102
- Add support for Rec2020 colour space in vc_image, IL, and MMAL
- Add full support for Argon10 as a new image format
- argon: Initial argon image format support
- warnings: Missing strlen declaration in fdt
- Renamed the DISPMANX_ID_HDMI* defines to be more consistent
- Large change to TVService to support multiple devices
- 2711: HDMI: EXPERIMENTAL - Dual HDMI support
- Fix tv_server so it responds with invalid call when unrecognised commmand sent
- vcos: Add reporting of which variant was built
- arm_loader/hdmi: Add mailbox call to set custom display timings
- vc-hdmi: Add HDMI_PICTURE_ASPECT_256_135 for DCI 4K
- debug_sym: Remove annoying message should fb copy fail
- Update vcdbg help
- interface: Drop vcfiled
- mmalomx_util_params_camera: Sync with vc4 tree
- IL: Add XRGB8888 and XBGR8888, and support on video_render, isp, and hvs
- Expose display timings via the mailbox
- HVS: Update HVS channel options to specify pixelvavle
- vcgencmd: Increase buffer size and ensure strings are null terminated
- Add AWB Grey World mode option.
- Fix for missing cleanup step for hello_videocube and hello_teapot
- Add media flushing call on when writing bitstream (#554)
- Fix for missing timestamps when data exceed one buffers worth (#553)
- Improve vcgencmd (#552)
- Update README.md
- mmal_vc_api: Report FLAG_TRANSMISSION_FAILED on VCHI bulk_rx failure
- raspicam: Set preview fps in raspivid and raspividyuv.
- Fix ups for James
- Review fixups
- buildme: Add option for ARM64 builds via either native or cross compile
- mmalcam: Create Makefile
- mmalplay: Create Makefile
- raspivid: Stop --raw option resetting --raw-format to YUV
- Fixed up overflow in microsecond timer
- fix cross-compile install failing
- Update README.md
- Allow aborting on write error to stdout when `-t 0` specified (#521)
- Move to standard Linux  microsecond count
- Added H264 slicing. (#486)
- Add GPS annotation to the camera apps output (#517)
- Merge pull request #508 from kaomoneus/issue-1077-attr_vertex2
- Added annotate options to raspiyuv and raspividyuv
- Removed version numbers, replace with commit ID (#510)
- Fixes up a merge mistake made when moving filenames to common code
- Moves common functions to the RaspiHelper code
- Moved common settings to own file
- Moved common settings to own file
- Reformat of source to userland coding standard
- Fixed #1077: hello_triangle2, vertex attribute of mandelbrot program is not
set up.
- Converted all the command ID's to enums
- Merge branch 'master' into wait_modes_indefinite_time
- Moved all camera 'setting' option code to single source
- Default runs that require interaction to infinite time
- raspivid: Fix so you can record raw without encoding too.
- dtoverlay: Use SUDO_USER in -pre and -post scripts
- Fix IL documentation omissions/errors.
- MMAL/IL: Add support for components to report alignment requirements.
- annotate: Add options to move the text and set justification
- vc_image: Add vpitch to linear RGB formats
- Updates for VS2017 compatibility
- image_fx: pass all user buffer flags.
- Add logging_messages to UART
- mmal: Remove unused mmal_metadata header file
- mmal: Populate buffer->type->video.flags field
- MMAL: Populate buffer header TYPE_SPECIFIC fields.
- mmal: Remove unused mmal_metadata header file (part 2)
- mmal: Remove unused mmal_metadata header file
- arm_dt: Work around an absent cache-line-size
- dtoverlay: More "reg" and "name" support
- dtoverlay: Also allow "fragment-<n>" in overlays
- dispmanx: Add option to ignore all layers lower than the current layer
- IL hvs component.
- Delay after first frame, burst-mode #494
- mmal: Correct encoding 4CC for SBGGR16
- Raspivid: Fix for bug where %%04d no longer works.
- mmal: Relax requirement on a buffer in mmal_port_send_buffer
- Raspistillyuv: Add option for bgr888 capture
- Raspivid: add an option to add sps timings (#488)
- Fix up typos in vcgencmd.h
- host_apps: Add --no-as-needed to stop libmmal_vc_client being dropped
- RaspiStill: Apply gpsd info as EXIF tags (#286)
- mmal: Add KEEP_PORT_FORMATS flag to mmal connection
- Raspicam: Update for justification and offset in annotation
- annotate: Add options to move the text and set justification
- hello_pi: encode: Clean up indentation to use 3 spaces and no tabs
- hello_pi: encode: Process the buffer before returning for filling.
- hello_pi: encode: Use portdef for generating the test card
- RaspiVidYuv: Don't enable video port if not capturing
- Raspi(Still)Yuv: Add support for -md to set the sensor mode
- Option to specify timestamp in the segment filename
- RaspiVidYuv: Check and disable the correct port on shutdown.
- Raspistill: Add support for TGA and PPM output
- Fixed up initial timelapse delay
- glxx_client: Fix glGetBufferParameteriv GL_BUFFER_SIZE
- glxx_client: Fix glMapBufferOES with GL_STREAM_DRAW
- RaspiVid: Return an error if the overall encode exceeds level 4.2
- Add bcm_host to ARM64 builds
- mmalomx: Add a README to say this library is deprecated.
- mmalomx_util: Correct mapping errors in mmalomx_param_mapping_fps_range
- pkgconfig: vcsm: Add -lvcos to Libs
- Update README.md
- Update README.md
- Update README.md
- vc_image: Add plumbing for side-by-side YUV420 format
- MMAL: Use calloc on some structures to make Valgrind happy
- Raspicam: Verbose does not need to be disabled when writing to stdout
- raspividyuv: Fix saving timestamps.
- Support for independant display configuration
- vc_image_helper: Add YUV 16 bit formats to second header
- vc_image: Add VC_IMAGE_TF_U8 and V8 to the ANY_TFORMAT case
- Video encode: Add option to set number of droppable P frames
- mmal/ril: Add MMAL_PARAMETER_VIDEO_ENCODE_SEPARATE_NAL_BUFS
- mmal_il: Add missing mappings for 8 bit Bayer encodings
- gx_create_window error cleanup fix
- Verbose is not disabled when capture is streamed
- Install interface/peer headers.
- user-vcsm: Add an interface to get a VideoCore address of handle (#445)
- dtoverlay app: Report unknown parameters in help
- dtoverlay app: Keep overlay symbols private
- host-apps/dtoverlay: don't install scripts in random location
- dtoverlay: Create "/aliases" node when needed
- Update README.md
- Include stdarg.h in dtoverlay.h
- raspicam: Improved readme with readme syntax (#439)
- RaspiVid: Print message stating TC358743 drivers are unsupported (#437)
- RaspiCamControl.c : Typo in digital gain
- Raspicam: Add manual controls for analog and digital gain.
- MMAL: Fix example_basic_2 to actually play video
- .gitignore: Ignore typical output files
- mmal_wrapper: Fix a short allocation for pools and queues (#426)
- interface: Remove some compiler warnings
- tvservice: Avoid unmatched reference counting on attach/unplugged events
- IL ISP: Add white balance and digital gain to ISP component
- IL Camera: Add manual analog and digital gain controls.
- vcsm: Add dmabuf import function.
- IL/MMAL: Add I420 and YUVUV 10bpp formats
- vcsm: Add new clean/invalidate command for 2D blocks
- hello_fft: Fixup offset calculation when mapping/unmapping buffers
- vc_image headers: Tidy up duplication
- IL ISP: Add option for adjusting the input CCM
- IL ISP: Add option to alter the shift in the output stage.
- Raspicam: Add command line option for flicker avoidance (#406)
- MMAL/RIL: Add mapping for OMX_IndexConfigCommon[In|Out]putCrop
- vc_image/mmal/il/isp: Add support for 16bit/component YUV420 and YUVUV
- vcdbg: Don't use dma when file provided
- vc_image/mmal/il/isp: Add support for 16bit/component YUV420 and YUVUV
- vc_image: Remove structure definition duplication
- dtoverlay: Short-circuit empty parameter handling
- tvservice: Avoid referencing uninitialised state when unsuccessful
- Camera/tuner: Allow client to override lens shading table.
- MMAL: Add support for the missing raw12, raw16, and 10to8dpcm formats
- vc_image: Add VC_IMAGE_PROP_VPITCH property
- dtoverlay app: Add the -D (dry-run) option
- dtoverlay: Update fixups when a node is renamed
- dtoverlay: Change node address when "reg" is set
- Make vchiq_test functional test more interesting.
- Escaped the * characters
- RaspiVid: Fix typo in help text for network streaming example.
- Use nproc build jobs
- Raspivid: fix uninitialised variable issue
- raspividyuv: Update file handling to include network and pts.
- Raspicam: Enable zero copy for the two raw capture apps
- Update comment for vc_dispmanx_resource_read_data
- cmake: Install user-vcsm.h to opt/vc/include/interface/vcsm
- warnings: Fix some mostly spurious warnings
- dtoverlay: Make empty alias a valid string
- dtoverlay: Add dt_node_is_enabled
- gpu_service: Add deinit call when service is finished with
- bcm_host: Honor previously set value of CMAKE_SHARED_LINKER_FLAGS
- ILCamera: Add option to disable ISP processing stages
- MMAL/IL: Allow video render to take non aligned sliceheight
- cmake: Expose all symbols from vchostif in bcm_host
- tvservice: Allow progressive composite modes to be chosen
- dtoverlay: find symbols, write properties
- RaspiStill: Fix regression in d35be767 - uninitialised variable
- gpuserv: Add new vchiq service for executing vpu and qpu jobs
- Zooming in, out and reset zoom while capturing video.  (#360)
- cec: Mark deprecated functions
- debug_sym: Use pointer type for user address
- Add pkg-config file for mmal
- RaspiStill: Read sensor information correctly if one of each type is attached.
- Fixed dummy error: SIGUSR2 should capture and exit even if verbose is false
- raspicam: Fix for Luma mode double sized files in timelapse
- RaspiStill.c : Fixed a typo
- Added SIGUSR2 signal to capture and exit immediatelly
- Fixed segmentation fault by parsing a network target file name if no port
given (raspivid -o tcp://1.1.1.1). (#359)
- Fix typo RaspiStill.c (#364)
- Example code for storing a FBO in VC shared memory
- Add EGL client support for EGL_IMAGE_BRCM_VCSM
- Define target for new EGL_IMAGE_BRCM_VCSM EGL extension
- vcfilesys.c: Use PRId64 c99 type for printing 64bit integer in portable way
(#358)
- vchiq_test: Fix client race condition
- Fix enum conversion warnings
- vcdbg: Use dma driver to access gpu memory
- RaspiVid: Add raw (YUV420, RGB or grayscale) video output
- mmal: Add missing struct field definition (#355)
- RaspiVid: Segment PTS file too if set
- RaspiVid: -sg option could try opening "null" file
- Raspistill: Only fail setting restart int if not 0
- hello_pi: Add hello_mmal_encode example (#349)
- Merge pull request #353 from Electron752/master
- buildme: fix whitespace (#352)
- Add ARM64 CMake variable for 64-bit targets
- vchiq_test: Fix race condition in clnt_callback
- Fix the minimum amount of pointer size related issues
- Add end bracket for cpp extern (#351)
- vc_image: Include colourspace in RGB to YUV conversions
- Video_decode: Check licenced codecs at component create
- MMAL: Add parameters to configure source pattern
- IL ISP: Major updates.
- mmal: improvements to mmal_queue code
- Merge pull request #341 from luked99/warnings/vcos_verify
- fix vcos_verify() warning: replace _verify() with _assert()
- vcos_verify() warnings - discard result from vcos_verify()
- buildme: avoid shell expansion of tr expression
- Merge pull request #336 from luked99/warnings/remove-vcos-get-free-mem
- Merge pull request #335 from luked99/warnings/fix-unused-definition
- Merge pull request #338 from adamheinrich/raspivid_unified_fopen
- Deprecate pthreads vcos_get_free_mem()
- Add build directory to .gitignore
- RaspiVid: Rename pts_file to pts_filename
- RaspiVid: Make open_filename() unified for all outputs (video, imv, pts)
- vcos: add VCOS_DEPRECATED macro
- Fix definition of UNUSED(x)
- RaspiVid: Use correct data type for the result of raspicli_unmap_xref()
- RaspiVid: Fix camera output port information in comments and messages
- Updates for vcdbg build
- VCOS Pthreads: assert mod
- tvservice/cecservice: We only care about unexpected message sizes
- vchiq: Allow inclusion from C++
- Remove unused files after #312
- Advertise sliced formats in MMAL_PARAMETER_SUPPORTED_ENCODINGS
- VCHI clients: Poll for messages until empty
- vmcs_host: Poll for multiple dispmanx messages
- MMAL: Add support for MMAL_ENCODING_xxx_SLICE formats
- Merge pull request #312 from luked99/fix-compiler-warnings
- Remove the unused usbdk code
- vchiq_arm: Fix return value of vchiq_initialise
- Add name to anonymous structs in RaspiCamControl.h
- RaspiVidYuv: Add option of saving RGB data.
- Raspi[Still|Vid]Yuv: Add option for just saving luma
- raspistill: Fix framestart off by one error
- raspistill: cosmetic: Whitespace cleanup
- mmal: Allow /dev/vchiq to be opened initialised prior to mmal_vc_init
- vc_client: Fix for sending vguPolygon data in chunks
- Update RaspiStill.c (#324)
- Raspistill: Add option to set the JPEG restart interval.
- image_encode: Add parameter to set the restart interval.
- deinterlace: Allow interlaced state of video buffer to be signalled from host
- wfc: Fix typo in comment
- arm_dt: Add macros for GETBE4 and SETBE4
- makefile: Switch to building and using GL libs with custom names
- Revert "cmake: mark GLESv2 as so version 2 for consistency with mesa lib"
- cmake: mark GLESv2 as so version 2 for consistency with mesa lib
- MMAL_VC_SHM: Explicitly lock buffer when requested
- vidtex: Remove unused variable
- khrn_client_platform_linux: Avoid uninitialised warnings
- RaspiVid: Fix printf format string
- tvservice: Avoid uninitialised variable warnings
- tvservice: Use correct aspect ratio string for sd
- vc_service: Avoid implicit cast warning
- message_dispatch: Initialise variable
- wfc: service is an integer type
- vc_service_common: Ensure error codes are unique
- vchiq_lib: Minor fixes
- vchiq_test: minor fixes
- vcos: Use vcos_free for vcos_malloc buffer
- Add --debug and --native options to buildme
- vcos: Implement vcos_strdup directly
- khronos: Use vchiq_get_client_id to determine global PID. (#315)
- Update raspicam helptext (#322)
- RaspiStill: Update annotation before capture (#321)
- Add option -lev/--level to raspvid to select H264 Level (#318)
- RaspiStillYuv: Detect and amend request for RGB pixel ordering
- Adjust include paths for Linux/BSD
- dtoverlay: Run scripts before and after changes
- cmake: generate and install pkgconfig files
- IL Components: Documentation update
- firmware: vcos: Fix incorrect licence
- Allow command-line overriding of VMCS_PLUGIN_DIR (#309)
- raspistill: Use camera_info component to set the sensor name and output
resolution of the captures. This queries the VC firmware for the camera
currently attached.
- dtoverlay: Require sudo for destructive operations
- dtoverlay: command line tweaks
- vc_image: Remove ifdefs for obsolete platforms
- dtmerge: Don't crash if the overlay fails to load
- dtoverlay: Copy overrides before applying
- vcilcs: Warn as message queue approaches fullness
- vcilcs: Increase ILCS queue size to prevent(?) deadlock
- dtmerge: Pack the merged DTB before writing
- dtoverlay: Copy overrides before applying
- Fix unixtime '1900' typo in raspistill --help (#308)
- Raspivid: Add option for MJPEG codec
- Merge pull request #299 from stweil/master
- Merge pull request #136 from ethanol100/fixIf
- host_applications: Fix typos in comments
- hello_video: Remove the timout, to avoid the application quits before the
ending of some videos
- hello_pi: Use absolute path for libs
- host_applications: Add dtmerge application
- dtoverlay: Multiple overlay instances
- dtoverlay: Support disabled (__dormant__) fragments
- dtoverlay: Allow aliases to be used with target-path
- Fix some typos found by codespell
- Merge pull request #294 from ggardet/master
- Merge pull request #283 from atupone/master
- Merge pull request #164 from lurch/patch-1
- Merge pull request #116 from jipe/master
- Merge pull request #296 from 6by9/PR20160228
- dtoverlay: Compile libfdt into libdtovl
- dtoverlay: Actually use the result of fread...
- dtoverlay: Fixing numerous compiler nit-picks
- vchiq_lib: Don't overwrite loop count mid-loop
- MMAL Examples: Some fixups for the Pi tree
- dtoverlay: Add makefile updates
- dtoverlay: Add source for libs
- dtoverlay: Add source for dtoverlay utility
- Flush stdout to ensure image is fully sent
- Raspivid: Add -pts to save timecodes to file
- Allow to override VMCS_INSTALL_PREFIX
- OpenMax IL: Add warning if OMX_SKIP64BIT is not defined
- cmake: define PROJECT_APIVER
- MMAL Examples: Some fixups for the Pi tree
- Fix some compiler warnings
- hello_triangle: Free all resources on exit
- Fix typos in various headers
- mmal: Fix warnings due to error types
- mmal: Remove unwanted loop increment from body of code
- Fix strict-aliasing
- Merge pull request #287 from jasaw/fix_warnings
- Update copyright
- cmake: Add -marm for building with generic toolchain
- Fix typos in various headers
- RaspiStill: fixed const char warning
- RaspiStill: fixed isdigit warning
- Add a flag to raspistill to start the frame number on something other than 0.
- Fix for format security errors in gcc5
- Fix a maybe uninitialized warning in gcc5
- Raspistill: Ensure filename doesn't contain invalid %% expansions
- RaspiCamControl: State EV step size
- Merge pull request #277 from 6by9/PR20151230
- VCOS: Silence compiler warnings due to missing functions on pthreads
- Raspicam: Send help text to stdout
- Raspicam: Remove RaspiCamDocs.odt as out of date
- Raspistill: Correct help text for DateTime (year not included)
- MMAL Examples: Some fixups for the Pi tree
- video_decode: Provide ability to limit the number of callback structures used
- IL ISP component support
- video_encode: option to add timing data to SPS header
- Fix error when building against musl libc.
- Fix build: add missing headers
- audioserv: Bump peer version and allow setting of channelmap
- vchiq: Add missing vcos library dependency
- tv_service: Add missing return statement
- vcos_assert: Swap order of message and bkpt for better gpu debugging
- camera: Allow loading of tuning data from a memory block
- vcilcs: Avoid a potential deadlock when very threaded
- determine better whether annotation is a bitmask or string
- Allow strftime parameters for text annotation, but only if bitwise date or
time expansion requested and the string contains a '%'.
- vc_dispmanx_display_open: allow display to be set with VC_DISPLAY env variable
- hello_video: Avoid hang on exit with some files
- tvserver: Make tvservice state report LCD state
- Merge pull request #248 from FIIT-TNL/master
- Added support for network and (optional) fflush to decrease latency.
- Fix build with glibc 2.22
- vchiq: Better error handling
- khronos: merge with more recent header file
- Merge pull request #171 from aizvorski/master
- Early frame sequential 3d support
- mmal_queue: Add sanity checking to avoid common queue errors
- Add MMAL to IL mapping for rawcam parameters
- vcsm: Add ioctl for custom cache flushing
- vcsm: Update to header from kernel side
- Added "all" target to hello_fft/makefile
- Enable VCSM in MMAL by default
- Alter buildme to use multiple jobs and install on a Pi2
- Fix intra-refresh port parameter setting.
- Fix typo in buildme shebang
- mmal: Pass dts in place of pts when pts is invalid
- mmal: Plumb in OMX_IndexParamBrcmInterpolateMissingTimestamps
- Merge pull request #233 from jsonn/patch-1
- Fix typo in header guard
- Use a more sensible check than a tautoligy
- Merge pull request #225 from 6by9/PR20150223
- dispmanx: Add stereoscopic flags to control 3d duplication behaviour
- Add an error message for MMAL_EVENT_ERROR
- Support for unescaping \n in annotate text
- Raspicam: Update to latest version of annotate API
- Add support for stereoscopic to Raspistill and Raspivid
- tvservice: Add option to choose frame packed hdmi mode
- vchiq: Add version define to indicate synchronous support
- raspicam: Fix minor typo in RaspiTexUtil
- mmal: Add MVC as a video encoding
- firmware: hello_fft: Update to version 3
- vdec3: preparation work for MVC
- Annotate: Add control of text size, colour, bg colour, and handle CR
- vcmailbox: Add utility app for driving mailbox interface from command line
- tvservice: Clear 3d settings before switching to new hdmi mode
- Annotate timelapse images with timestamp or datetime
- cmake: Add -fPIC to avoid linking issues with Pi2 compile flags
- include: Add mmal_events_private.h to installed header files
- vc_dispmanx: Fix update/vsync callbacks
- Added a new annotate feature that works on stills and video.
- Merge pull request #200 from ethanol100/FixCommandTimeout
- Merge pull request #211 from JamesH65/raspividyuv
- hello_fft: Use addresses from device tree rather than hard-coded constants
- Added a new camera application, raspividyuv, which produces raw
- userland: hello_fft: Update to release 2.0
- mmal: don't use bulk transfers for clock buffers
- mmal-vc-diag: add memory compaction command
- mmalplay: add cmd line option for routing video
- mmal: allow non-tunnelled clock port connections
- mmal/graph: remove spurious error message
- mmal/omx: fix bug in channel mapping
- vcos: fix vcos logging on arm userland
- containers: Fixed compile flags to select C99
- vmcs_host: Correct type name for file mode
- vmcs_host: Only check __USE_FILE_OFFSET64 when compiling against glibc
- vcos: Fixed include for "HZ"
- vcos: Remove timer_t fallback definition
- vc_dispmanx: Fix vsync service use counting
- IL: Add parameter for setting dynamic resample ratio for audio_mixer
- VCHIQ: Add per-service tracing
- mmal: allow user flags to be passed through to omx and returned
- Use PROJECT_SOURCE_DIR instead of CMAKE_SOURCE_DIR
- services: Avoid bad behaviour from calling init functions more than once
- Raspicam: Add option to force the sensor mode.
- raspicam: option to enable stats pass on captures
- containers: add standalone CMakelists.txt
- makefiles: Include vcsm and debug_sys libs
- Add missing vidtex demo app
- mmal: Add mmal_vc_diag code
- mmal: Add test code
- mmal: Add test apps mmalcam and mmalplay
- mmal: Add MMAL container parsing code
- hello_pi: Link with math lib
- hello_fft: Update to latest version from Andrew
- Fix if condition to not overwrite already set frameNextMethod.
- omx: Use define for IMAGEFILTERPARAMS_MAXPARAMS
- mmal: Add plumbing to query interlaced format from video_decode
- vchi: Remove unimplemented prototype
- Annotate: Add option for frame counter and black background
- mmal: Update to latest upstream code
- Merge pull request #195 from chinasaur/background_offset
- Additional documentation.
- Fix bug in y offset of text background.
- raspistill: Add stdout flush
- mmal: Initial stereoscopic camera work
- mmal: Add call to check for connected port
- Subject: [PATCH] VCHIQ: Make service closure fully synchronous (lib)
- dispmanx: Add a host call to trigger callbacks on vsync
- hello_jpeg: Handle jpegs where dimensions aren't contained in first 80k
- Fix line_extent calculation; kerning was broken.
- Merge pull request #185 from zboobzor/master
- mmal: Add stereo display modes from omx world
- Add annotate stage to Raspberry Pi Full variant. Allow config
- MMAL: Correct parameter names for denoise control
- cosmetic: Whitespace tidy
- vcinclude: Try to define bool_t in a way less likely to conflict with other
includes
- MMAL: Fix two memory leaks in MMAL vc component.
- Pull latest vcos_msgqueue from vc4/DEV
- vmcs_host: Fix missing install of libvcilcs.so
- tvservice: Fix typo in vc_tv_hdmi_power_on_explicit
- mmal: Add MMAL parameters for disabling stills and video denoise algos
- Correct MMAL_PARAMETER_PRIVACY_INDICATOR_T structure
- mmal: Add MMAL_BUFFER_HEADER_FLAG_DECODEONLY flag
- Merge pull request #192 from chinasaur/text_extents
- Fixed bug.
- Add burst mode to raspistill/raspiyuv and settings and long exposure to
raspivid
- Include some features from RaspiStill.c in RaspiStillYUV.c
- Fix merging snafu
- Support for multiple cameras
- userland: egl: Call khrn_init_options so env vars like V3D_DOUBLE_BUFFER are
respected
- Change the requested frame rate on longer exposure times
- Raspistill: Add support for requesting camera settings (--settings)
- Build libvcsm and vcsmem test utility
- Add MMAL parameter for render stats
- Add MMAL parameter for privacy indicator control
- Add MMAL callbacks for various camera parameters
- OMX: Add OMX_ImageFilterDeInterlaceFast option
- Update raspivid help and README.md explaining the use of 0 with the --intra /
-g option.
- Allow a value of 0 with the --intra / -g option, which is handled by the codec
as only send an I-frame on the first frame and never again.
- imagefx: Add new effect to convert 3D video to anaglyph
- video_render: Add config option to read rendering statistics
- hello_fft: fix warning during build
- Merge pull request #183 from JamesH65/drc
- Added a default for DRC, and also added the DRC options to the help text.
- Merge pull request #181 from JamesH65/drc
- Add DRC (Dynamic range compression) enable/disable to the raspicamcontrol code
- tvservice: Make HDMI attached messages less ambiguous
- display: Add support for 32bpp palettes
- hello_fft: Add qasm source files
- mmal: Adds the two new effects parameters
- userland: User /bin/bash for buildme script
- egl: remove assert on surface size - zero sized surfaces are okay
- gpu_fft: Update help file to describe issues when using with 3d
- Added copyright to the new created c files
- Update README.md
- Option to save the inline motion vectors to a file
- Add exposure=off option
- RaspiVid: Fix file splitting code.
- Allow stereo view modes to be selected
- tvservice: Allow requesting ntsc frequencies
- dispmanx: Add new display numbers for controlling display output device
- encode: Add support for saving inline motion vectors from gsh
- tvservice: report framerate including nstc clock
- Fix comment markup typos
- Merge pull request #162 from julianscheel/master
- tvservice: Increase max callback count to 5
- tvservice: Add callback unregister with data pointer check
- vcos: Add prototype for vcos_semaphore_wait_timeout (for GPU side)
- ILCamera: Add option to remove all padding from the output images.
- mmal: Add queue_timedwait
- Fix vcos_semaphore_wait_timeout
- Merge pull request #158 from JamesH65/fixed_awb_fix
- Merge in the fixed AWB changes from DavidS
- Patched in DavidS changes to fix up the preview modes
- mmal: Add controls for enabling SEI
- mmal: Add controls for manual AWB gains
- Fix for two bugs
- hello_pi: Update the texture coordinates to match latest firmware
- Changes for high frame rate modes and full FOV preview modes for stills
- Update frame rate settings to work correctly with new fixes to
- raspistill: Fix not copying the terminating byte of filename
- hello_pi: Fix rebuild script for hello_fft
- vcos: cleanup dummy threads properly
- hello_pi: Add missing execute permission to rebuild.sh
- hello_pi: Add hello_fft demo app from Andrew Holme
- interface: Updates from vdec3 firmware update
- hello_pi: Tidy up hello_video code
- Merge pull request #139 from aizvorski/master
- Make constant QP mode actually have constant QP
- Add cmake rules to install mmal headerfiles to
/opt/vc/include/interface/mmal/*
- Wrong sign in if condition
- Add circular buffer mode.
- Fix "Invalid command line option" message - invalid arg index was used
- mmal: Add MPJEG fourcc type
- hello_pi: Tidy up of hello_videocube apps
- Added -sn flag to set initial segment number.
- Merge pull request #130 from JamesH65/colfx_bugfix
- Merge pull request #127 from cybear/patch-1
- Merge pull request #124 from ethanol100/splitForWaitMethods
- Issue #11 (jamesh65/userland) colfx options not working correctly
- Fix spelling error in raspistill
- RaspiStill example code for YUV fast paths
- Add switch -sp to split files in signal/keypress (and other WaitMethods) modes
- Merge pull request #123 from JamesH65/segmentation
- mmal: Avoid building mmal components and add rules for mmal_vc_diag
- vcos: log messages to stderr rather than stdout
- Segmentation option for multiple files generated from a stream.
- Add a inline headers option. Inserts PPS and SPS headers
- Add a quantisation parameter to raspivid to allow greater control
- RaspiStill: Add option to render preview via GL.
- Fixed variable name error in code example doc
- dispmanx: Add api to set palette of resource
- mmal: Add system time parameter
- Merge pull request #113 from JamesH65/bug_fixes
- add -D_FILE_OFFSET_BITS=64 to fix 2gb file size limit
- Sets max bitrate for record at 25Mbits/s
- Merge pull request #106 from barmaglot27/master
- make stills without thumbnails and EXIF tags to minimize jpeg size
- Userland issue #76
- mmal: Add Inline headers option for H264 encoding, plus some other video
options.
- Refactored raspivid to allow user to pause and restart captures
- Added a signal mode to allow initiation of captures from another process.
- Shuffled around the capture loop to provide better facility
- userland #35 Removed exposure off option
- userland #66
- userland #66
- Fixed a problem with some strings not being free'd inside a loop
- Merge pull request #91 from JamesH65/h264_profile
- userland #64
- Userland #80
- Update headers from latest firmware
- Update RaspiStill.c
- Periodic timelapse
- Native build
- add OMX helpers for DRC
- Use open/write/rename to prevent partial image files.
- Merge pull request #73 from JamesH65/roi4
- Added -roi command to allow specification of the area of the sensor to use as
input
- dispmanx: Correct VC_IMAGE_TRANSFORM_T to DISPMANX_TRANFORM_T where
appropriate
- audio: add support for arbitrary 8x8 channel mixing to be specified from host
- Merge pull request #65 from JamesH65/compile_fix
- Fix for compile fault due to mising change in the RaspiPreview.h header file.
- Merge pull request #62 from JamesH65/new_preview
- Merge pull request #61 from JamesH65/raw_rgb
- Merge pull request #58 from JamesH65/iso_fix
- Fixed up preview mode to use a null sink rather than not connecting
- Added the option to save the raw data as RGB888. This requires a change to the
firmware.
- Re-enabled ISO setting - tests show (in EXIF data of test jpegs) you can set
between 100 and 800.
- Merge pull request #57 from JamesH65/camera_dev
- Fixed up so RAW works for each capture in timelapse mode
- hello_audio: support different sample rates
- Merge pull request #55 from JamesH65/camera_dev
- hello_audio: better support for multichannel
- Fixed up EXIF setting as sending data whilst encoder port was active
- RaspiCam: Added timelapse mode to RaspiStillYUV
- RaspiCam:
- tvservice: allow HDMI/DVI mode to be specified
- tvservice: indicate preferred mode
- Merge pull request #54 from towolf/master
- Copy help from odt file to README.md for GitHub (and remove README)
- raspicam: status should be initialised to fail
- hello_pi: Make it clearer how to build on pi and cross-compile
- Merge pull request #45 from AndyA/notimeout
- Make it possible to disable the timeout on raspivid.
- Option to set intra refresh period.
- Add -c to CMAKE_ASM_FLAGS which was causing a build issue in some environments
- raspicam: Fixes from James for:
- Add hello_videocube to rebuild.sh
- raspicam: Avoid losing failure status
- Updated camera apps, add flips and better diagnostics
- Reduce error level of no CEA/DMT modes supported
- Rename raspicam to raspistill
- raspivid: Add option to output to stdout
- Remove warnings and add bitrate option
- Fix bug in length calculation of vc_dispmanx_resource_write_data
- Add default enum to pixel encodings
- Add callback function option to vchi_bulk_queue_receive_reloc to specify
copy_pagelist function
- Always use platform_tls_get_check to avoid corruption issue with eglGetDisplay
- Remove redundant VCOS_SEMAPHORE_T typedef.
- Add camera demo apps. Thanks jamesh
- Avoid unitialialised variable warning
- Load eglIntOpenMAXILDoneMarker() explicitely via dlsym() instead of having a
stub in libEGL and libbcm_host
- Add new hello_teapot demo app, and tweak some apps
- Clean up hello_videocube. Thanks @fieldOfView
- Remove find_start_codes from hello_video
- Add hello_videocube demo. Thanks to OtherCrashOverride.
- Fix for segmentation Fault in hello_video on OMX_Deinit
- Fix include path for hello pi and updated header files
- mmal_vc_api.c assert fix.
- Update userland to match latest firmware.
- Merge pull request #8 from bavison/master
- Merge pull request #7 from maxnet/master
- Accelerated the khrn_hashword() function.
- Update master branch to next
- Test for the existence of execinfo.h
- Fix location of bcm_host.h
- Add hello_pi apps and bcm_host.h to userland. Merge with latest code.
- Fix undefined reference
- Initial import of userland code
- Initial commit
